''*****************************
''*  16Colour Bitmap          *
''*  (C) 2009 Jim Bagley      *
''*  + some animation demos   *
''*     Peter Jakacki         *
''*****************************

CON

'{Hybrid Setup
_clkmode = xtal1 + pll16x
_xinfreq = 6_000_000
modepins = %011_0000
'}

{Proto/Demo Board Setup
  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000
  modepins = %001_0101
'}

{Hydra Setup
_clkmode = xtal1 + pll8x
_xinfreq = 10_000_000
modepins = %011_0000
'}

PAL=%0001
NTSC=%0000
INTERLACED=%0010

x_tiles = 8 '*16=256            ' 128 bytes/line
y_tiles = 12 '*16=192
mode = 0
my_hx = 22+((mode&1)<<1)

x_pixels = x_tiles*16
y_pixels = y_tiles*16

bcnt = 128*191
clockfreq = ((_CLKMODE - XTAL1) >> 6) * _XINFREQ
_1mS  = clockfreq /     1_000 'Divisor for  1mS

  maxSprites = 8

OBJ
  tv    : "JB_TV_AMS_01"
  font  : "Font_ATARI"
  
VAR
  long  frame

  byte  Sprites[16*16*maxSprites]
  byte  Shadows[16*16*maxSprites]

  byte  SpriteXSZ[maxSprites]
  byte  SpriteYSZ[maxSprites]
  byte  shadowX[maxSprites]
  byte  shadowY[maxSprites]


PUB Main | i,ix,iy,ii,c,x,y,ix2,iy2

  tv.start(@tvparams)
  frame~
  MakeSprite(0,56,106,14,16)
  MakeSprite(1,104,114,6,4)

  print(string("HELLO WORLD"),16,0,1,0)

  bytefill(screen(0,96),0,(158-96)<<6)

  ix := 56
  iy := 106
  ix2 := 104
  iy2 := 114
  ii := 2
  repeat
    VSync

    repeat y from 159 to 191
      i := @data+(y<<6)
      c := byte[ i ]
      bytemove(i,i+1,63)
      byte[i+63] := c
{
    repeat y from 64 to 95
      i := @data+(y<<6)
      c := byte[ i ]
      bytemove(i,i+1,63)
      byte[i+63] := c
}
    DrawSprite(0,ix,iy)
    'DrawSprite(1,ix2,iy2)

    ms(30)

    ix2 += 2
    ix2 &= 127

    ix += 2
    iy += ii
    if iy > 140
      ii := -2
    if iy == 70 '96
      ii := 2
    ix &= 127


pub MakeSprite(n,x,y,xsz,ysz) | i
  spriteXSZ[n] := xsz
  spriteYSZ[n] := ysz
  repeat i from 0 to ysz
     bytemove(@sprites[(n<<8)+(i<<4)], @data+(x>>1)+((y+i)<<6), xsz>>1)

pub DrawSprite(n,x,y) | i
  x &= 127
  RestoreShadow(n)              ' undraw previous sprite position
  SaveShadow(n,x,y)
  repeat i from 0 to spriteYSZ[n]
    bytemove(screen(x,y+i), @sprites[(n<<8)+(i<<4)], spriteXSZ[n]>>1)


pub SaveShadow(n,x,y) | i
  shadowX[n] := x               ' remember the position of the shadow
  shadowY[n] := y

  repeat i from 0 to spriteYSZ[n]
     bytemove(@shadows[(n<<8)+(i<<4)], @data+(x>>1)+((y+i)<<6), spriteXSZ[n]>>1)

pub RestoreShadow1(n) | i
  repeat i from 0 to spriteYSZ[n]
    bytefill(screen(shadowX[n],shadowY[n]+i),$11,spriteXSZ[n]>>1)

pub RestoreShadow(n) | i
  'if shadowx[n] + shadowy[n]
    repeat i from 0 to spriteYSZ[n]
       bytemove(screen(shadowX[n], shadowY[n]+i), @shadows[(n<<8)+(i<<4)], spriteXSZ[n]>>1)

pub screen(x,y)
  result := @data+(x>>1)+(y<<6)



pub demo | i,c,x,y
  repeat 5*60
    VSync

  c:=0
  repeat i from 0 to 63
    repeat x from i to 127-i
      plot(x,i,c)
      c++
    repeat y from i to 191-i
      plot(127-i,y,c)
      c++
    repeat x from i to 127-i
      plot(127-x,191-i,c)
      c++
    repeat y from i to 191-i
      plot(i,191-y,c)
      c++
    VSync

  c:=0
  repeat i from 63 to 1         ' back down to 1, to leave a border of colours onscreen
    repeat x from i to 127-i
      plot(x,i,c)
    repeat y from i to 191-i
      plot(127-i,y,c)
    repeat x from i to 127-i
      plot(127-x,191-i,c)
    repeat y from i to 191-i
      plot(i,191-y,c)
    VSync

  repeat
'    VSync
    repeat 500
    bordercolour:=$2d-bordercolour

PUB print(s,x,y,c,b)            ' s=string, x,y obvious c=colour,b=background colour -1=transparent background
  repeat while byte[s][0]
    prtchr(byte[s][0],x,y,c,b)
    s++
    x+=8

PUB prtchr(ch,x,y,c,b) | f,xx,yy
  f:=font.GetPtrToFontTable+(ch<<3)
  repeat yy from 0 to 7
    repeat xx from 0 to 7
      if(byte[f][0]&(|<(7-xx)))
        plot(x+xx,y+yy,c)
      else
        if(b<>-1)    
          plot(x+xx,y+yy,b)
    f++
  
PUB plot(x,y,c)
  if(x<0 or x=>x_pixels or y<0 or y=>y_pixels)
    return
  c&=15
  if(x&1)
    data[y<<6+x>>1]:=(data[y<<6+x>>1]&$f0)+c
  else
    data[y<<6+x>>1]:=(data[y<<6+x>>1]&$0f)+(c<<4)
    
PUB VSync
  repeat until VSyncFlag<>1
  repeat until VSyncFlag==1

PUB ms(Period)
  if Period                                    '1 mS
    waitcnt(_1mS * Period + cnt)

DAT

tvparams      long    0               'status
              long    1               'enable
              long    modepins        'pins ' PROTO/DEMO BOARD = %001_0101 ' HYDRA = %011_0000
              long    mode            'mode
              long    x_tiles         'hc
              long    y_tiles         'vc
              long    my_hx           'hx
VSyncFlag     long    0
nextline      long    0                        
disp_ptr      long    @data+$10
bordercolour  long    $02
              long    @palette+$10

palette       byte    $02,$07,$28,$8d,$ba,$1a,$db,$3d,$8f,$5f,$3f,$5b,$d8,$04,$02,$02

data          file    "mrheli.bit"

